/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2020 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef EXTENSIONMIDI_GLOBALKEYBOARD_CHANNELSELECTOR_H
#define EXTENSIONMIDI_GLOBALKEYBOARD_CHANNELSELECTOR_H

#include <QWidget>

namespace Ui {
class ExtensionMidi_GlobalKeyboard_ChannelSelector;
}

class ExtensionMidi_GlobalKeyboard_ChannelSelector : public QWidget
{
    Q_OBJECT

public:
    explicit ExtensionMidi_GlobalKeyboard_ChannelSelector(QWidget *parent = nullptr);
    ~ExtensionMidi_GlobalKeyboard_ChannelSelector();

    // Channel from 0 to 15 included
    void setMidiChannel(int channel);
    int getMidiChannel() { return _currentMidiChannel; }

    static void keyTriggeredForChannel(int channel);

signals:
    void midiChannelChanged(int midiChannel, bool keepInternal);

protected:
    QSize minimumSizeHint() const override;

private slots:
    void on_pushScan_clicked();
    void on_comboChannel_currentIndexChanged(int index);
    void onFocusOut();

private:
    void changeState(bool isScanMode);

    Ui::ExtensionMidi_GlobalKeyboard_ChannelSelector *ui;
    int _currentMidiChannel;

    static QList<ExtensionMidi_GlobalKeyboard_ChannelSelector *> s_instances;
};

#endif // EXTENSIONMIDI_GLOBALKEYBOARD_CHANNELSELECTOR_H
