/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2020 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef EXTENSIONMIDI_GLOBALKEYBOARD_GUI_H
#define EXTENSIONMIDI_GLOBALKEYBOARD_GUI_H

#include <QWidget>
#include "soundfontmanager.h"
class QPushButton;
class ExtensionMidi_GlobalKeyboard_Configuration;

namespace Ui {
class ExtensionMidi_GlobalKeyboard_Gui;
}

class ExtensionMidi_GlobalKeyboard_Gui : public QWidget
{
    Q_OBJECT

public:
    ExtensionMidi_GlobalKeyboard_Gui(ExtensionMidi_GlobalKeyboard_Configuration * extensionConfig);
    ~ExtensionMidi_GlobalKeyboard_Gui();

    void inputNote(int channel, int key, int vel);

protected:
    void resizeEvent(QResizeEvent * event) override;

private slots:
    void onEditingDone(QString editingSource, QList<int> sf2Indexes);
    void onSoundfontLoaded(int sf2Index);
    void onSoundfontClosed(int sf2Index);
    void onAddKeyboardClicked(bool checked);
    void onSplitterMoved(int pos, int index);
    void onChannelChanged();
    void onPushRemoveClicked();

private:
    void updateCellHeight();
    void addKeyboard(int channel = -1);

    Ui::ExtensionMidi_GlobalKeyboard_Gui *ui;
    ExtensionMidi_GlobalKeyboard_Configuration * _extensionConfig;
    QPushButton * _newKeyboardButton;
};

#endif // EXTENSIONMIDI_GLOBALKEYBOARD_GUI_H
