/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2020 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef EXTENSIONMIDI_GLOBALKEYBOARD_KEYBOARDCELL_H
#define EXTENSIONMIDI_GLOBALKEYBOARD_KEYBOARDCELL_H

#include <QWidget>

namespace Ui {
class ExtensionMidi_GlobalKeyboard_KeyboardCell;
}

class ExtensionMidi_GlobalKeyboard_KeyboardCell : public QWidget
{
    Q_OBJECT

public:
    explicit ExtensionMidi_GlobalKeyboard_KeyboardCell(int channel, QWidget *parent = nullptr);
    ~ExtensionMidi_GlobalKeyboard_KeyboardCell();

    int getChannel();
    void disableRemoveButton();

    void inputNote(int key, int vel);

    bool hasHeightForWidth() const override { return true; }
    int heightForWidth(int width) const override;

signals:
    void channelChanged();
    void pushRemoveClicked();

private slots:
    void on_pushRemove_clicked();
    void onMidiChannelChanged(int midiChannel, bool keepInternal);

private:
    Ui::ExtensionMidi_GlobalKeyboard_KeyboardCell *ui;
};

#endif // EXTENSIONMIDI_GLOBALKEYBOARD_KEYBOARDCELL_H
