/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2020 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef EXTENSIONMIDI_GLOBALKEYBOARD_PRESETCELL_H
#define EXTENSIONMIDI_GLOBALKEYBOARD_PRESETCELL_H

#include <QWidget>
class ExtensionMidi_GlobalKeyboard_Configuration;

namespace Ui {
class ExtensionMidi_GlobalKeyboard_PresetCell;
}

class ExtensionMidi_GlobalKeyboard_PresetCell : public QWidget
{
    Q_OBJECT

public:
    explicit ExtensionMidi_GlobalKeyboard_PresetCell(
            ExtensionMidi_GlobalKeyboard_Configuration * extensionConfig,
            int channel, int indexSf2, int indexElt,
            QWidget *parent = nullptr);
    ~ExtensionMidi_GlobalKeyboard_PresetCell();

    void clear();

private slots:
    void on_check16_stateChanged(int arg1);
    void on_check8_stateChanged(int arg1);
    void on_check4_stateChanged(int arg1);

private:
    void storeState();

    Ui::ExtensionMidi_GlobalKeyboard_PresetCell *ui;
    ExtensionMidi_GlobalKeyboard_Configuration * _extensionConfig;
    int _channel;
    int _indexSf2;
    int _indexElt;
};

#endif // EXTENSIONMIDI_GLOBALKEYBOARD_PRESETCELL_H
