/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2020 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef EXTENSIONMIDI_GLOBALKEYBOARD_PRESETTABLE_H
#define EXTENSIONMIDI_GLOBALKEYBOARD_PRESETTABLE_H

#include <QTableWidget>
class ExtensionMidi_GlobalKeyboard_Configuration;
class ExtensionMidi_GlobalKeyboard_PresetCell;

class ExtensionMidi_GlobalKeyboard_PresetTable : public QTableWidget
{
    Q_OBJECT

public:
    ExtensionMidi_GlobalKeyboard_PresetTable(QWidget *parent = nullptr);

    void updateTable(ExtensionMidi_GlobalKeyboard_Configuration * extensionConfig);

private slots:
    void onClearClicked(bool checked);

private:
    class PresetRow
    {
    public:
        PresetRow(int indexElt, quint16 bank, quint16 preset, QString name) :
            _indexElt(indexElt),
            _bank(bank),
            _preset(preset),
            _name(name)
        {}

        int _indexElt;
        quint16 _bank;
        quint16 _preset;
        QString _name;
    };

    QList<PresetRow> getPresetList(int indexSf2);
    QMap<int, QMap<int, QList<ExtensionMidi_GlobalKeyboard_PresetCell *>>> _cellBySf2AndChannel;
    QString _clearColor;
};

#endif // EXTENSIONMIDI_GLOBALKEYBOARD_PRESETTABLE_H
