/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2020 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef EXTENSIONVIEW_BARS_GRAPHICS_KEY_H
#define EXTENSIONVIEW_BARS_GRAPHICS_KEY_H

#include <QGraphicsItem>
#include <QBrush>
#include <QPen>

/// Graphical element used to display the notes that are being played
/// with a circle that is fading in 1 second approximately
class ExtensionView_Bars_Graphics_Key : public QObject, public QGraphicsItem
{
    Q_OBJECT
    Q_INTERFACES(QGraphicsItem)

public:
    ExtensionView_Bars_Graphics_Key(QGraphicsItem *parent = nullptr);

    void setKey(int key) { _key = key; }
    QRectF boundingRect() const override;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem * option, QWidget * widget = nullptr) override;

private slots:
    void updateColor();

private:
    int _key;
    QColor _color;

    static const double s_width;
    static const int s_maxAlpha;
};

#endif // EXTENSIONVIEW_BARS_GRAPHICS_KEY_H
