/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2020 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef EXTENSIONVIEW_BARS_GRAPHICS_LEGENDITEM2_H
#define EXTENSIONVIEW_BARS_GRAPHICS_LEGENDITEM2_H

#include <QGraphicsItem>
#include <QFont>
#include <QBrush>
#include <QPen>
#include "basetypes.h"

class ExtensionView_Bars_Graphics_LegendItem2 : public QGraphicsItem
{
public:
    ExtensionView_Bars_Graphics_LegendItem2(QString fontFamily, QGraphicsItem *parent = nullptr);

    void setAttribute(AttributeType attributeType, bool isPrst)
    {
        _attributeType = attributeType;
        _isPrst = isPrst;
    }
    void setNewValue(bool isDisplayed, double value);
    void setLeft(bool isLeft);
    void setOffsetY(double offsetY) { _offsetY = offsetY + 1.5 * s_border; }

    QRectF boundingRect() const override;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem * option, QWidget * widget = nullptr) override;

private:
    AttributeType _attributeType;
    bool _isPrst;

    static const int s_border;
    QBrush _foregroundBrush;
    QPen _borderPen;
    QPen _textPen;

    const QFont _font;
    QStringList _text;
    int _alignment;
    double _offsetY;

    QSizeF getTextSize() const;
    qreal dx(QSizeF size) const;
    qreal dy(QSizeF size) const;
};

#endif // EXTENSIONVIEW_BARS_GRAPHICS_LEGENDITEM2_H
