/***************************************************************************
**                                                                        **
**  Polyphone, a soundfont editor                                         **
**  Copyright (C) 2013-2020 Davy Triponney                                **
**                                                                        **
**  This program is free software: you can redistribute it and/or modify  **
**  it under the terms of the GNU General Public License as published by  **
**  the Free Software Foundation, either version 3 of the License, or     **
**  (at your option) any later version.                                   **
**                                                                        **
**  This program is distributed in the hope that it will be useful,       **
**  but WITHOUT ANY WARRANTY; without even the implied warranty of        **
**  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the          **
**  GNU General Public License for more details.                          **
**                                                                        **
**  You should have received a copy of the GNU General Public License     **
**  along with this program. If not, see http://www.gnu.org/licenses/.    **
**                                                                        **
****************************************************************************
**           Author: Davy Triponney                                       **
**  Website/Contact: https://www.polyphone-soundfonts.com                 **
**             Date: 01.01.2013                                           **
***************************************************************************/

#ifndef EXTENSIONVIEW_BARS_PAGE_H
#define EXTENSIONVIEW_BARS_PAGE_H

#include "page.h"

namespace Ui {
class ExtensionView_Bars_Page;
}

class ExtensionView_Bars_Page: public Page
{
    Q_OBJECT

public:
    explicit ExtensionView_Bars_Page(QWidget *parent = nullptr);
    ~ExtensionView_Bars_Page();

    bool isSuitableFor(ElementType elementType) override
    {
        return elementType == elementInst || elementType == elementInstSmpl ||
                elementType == elementPrst || elementType == elementPrstInst;
    }

    QString getLabel() override { return tr("Bars"); }
    QString getIconName() override { return ":/icons/bars.svg"; }

protected:
    void updateInterface(QString editingSource) override;
    void keyPlayedInternal(int key, int velocity) override;

private slots:
    void onRadioButtonClicked();
    void on_pushSplit_clicked();

private:
    AttributeType getAttribute();
    void updatePushSplit(IdList ids);
    IdList splitId(EltID id);
    void duplicateGenMod(EltID idFrom, EltID idTo);

    Ui::ExtensionView_Bars_Page *ui;
    IdList _currentParentIds;
};

#endif // EXTENSIONVIEW_BARS_PAGE_H
